package com.kakao.sdk.partner.auth

import com.kakao.sdk.auth.RxAuthApiManager
import com.kakao.sdk.auth.model.OAuthToken
import com.kakao.sdk.auth.network.rxKauth
import com.kakao.sdk.network.ApiFactory
import io.reactivex.Single

private val authApi: RxPartnerAuthApi
    get() = ApiFactory.rxKauth.create(RxPartnerAuthApi::class.java)

/**
 * @suppress
 */
internal fun RxAuthApiManager.issueAccessToken(groupRefreshToken: String): Single<OAuthToken> =
        authApi.issueAccessToken(
                groupRefreshToken,
                clientId = applicationInfo.appKey,
                androidKeyHash = contextInfo.signingKeyHash,
                approvalType = approvalType.value
        )
                .compose(RxAuthApiManager.handleAuthError())
                .map { OAuthToken.fromResponse(it) }
                .doOnSuccess { tokenManagerProvider.manager.setToken(it) }